package Insert_parts;
#
#

use strict;

use Doctaur_libs::Get_conf;
use Doctaur_libs::Get_params;
use Doctaur_libs::Pass_control;

sub open
{
   my ($pkg) = @_;
   my $conf = Get_conf->open();
   my $params = Get_params->open();
   my $pass_control = Pass_control->open($conf);
   my $script_name = $ENV{'SCRIPT_NAME'};
   my $script_name_wo = $script_name;
   $script_name_wo =~ s/\.[^\.]*$//;
   $script_name_wo =~ s/^.*\///;   
   my $qs = $ENV{'QUERY_STRING'};
   return (bless{
               conf=>$conf,
               params=>$params,
               pass_control=>$pass_control,
               script_name=>$script_name,
               script_name_wo=>$script_name_wo,               
               qs=>$qs
               }, $pkg);
}


sub get_converted_char
{
    my ($obj, $char) = @_;
    #return '%'.ord($char);
    return '%'.unpack("H*", $char);
}


sub insert_all_behind_body
{
   my ($obj, ) = @_;
   
   print "Content-type: text/html\n\n";

   $obj->insert_head();
   $obj->insert_body_first_part();
   
   print qq!            
                  <tr>
                    <td  class="topcrossframe">
                      <table cellspacing="0" cellpadding="0" border="0" width="100%">
                        <tr><td class="topcrossframe" align="left" nowrap="nowrap" >
                    !;
   $obj->insert_menu();
   print qq!
                        </td>
                        
                        <td class="search" align="center" colspan="2">
                            <table cellpadding="0" cellspacing="0" border="0">
                                <tr>
                                    <td width="10">&nbsp;</td>
                                    <td class="search_border"><img src="redirection.pl?type=img&which=trn.gif" width="1" height="1" alt="" /></td>
                                    <td width="10">&nbsp;</td>
                                    <td class="search" align="right">
                                        
   !;
   $obj->insert_search_or_description();
   print qq!
                                    </td>
                                    <td width="10">&nbsp;</td>
                                    <td class="search_border"><img src="redirection.pl?type=img&which=trn.gif" width="1" height="1" alt="" /></td>                                                                    
                                    <td width="10">&nbsp;</td>
                                </tr>
                            </table>
                          </td>
                          <td class="topcrossframe" align="center">
                             <a href="http://www.doctaur.com/cgi-bin/redirection.pl?type=af&which=mysql">
                              <img src="redirection.pl?type=img&which=mysql_blue_small.png" border="0" alt="order MySQL">
                             </a>
                          </td>
                          
                        </tr>
                      </table>
                    </td>
                  </tr>
                <tr>
                   <td class="frame" ><img src="redirection.pl?type=img&which=trn.gif" width="1" height="1" alt="" /></td>
                </tr>
   !;
}

sub insert_head
{
    my ($obj) = @_;
   my $js_link = '<script type="text/javascript" src="redirection.pl?type=root&which=doctaur.js"></script>';
   if ($obj->{conf}->get('intranet_version') eq 'no')
   {
      $js_link = '<script type="text/javascript" src="redirection.pl?type=root&which=doctaur_com.js"></script>';
   }
    print qq!<?xml version="1.0" encoding="iso-8859-1"?>
<\!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en"> 
         <head>
            <title>DocTaur - intranet software</title>
            $js_link
         </head>
    !;
}

sub insert_body_first_part
{
    my ($obj) = @_;

   my $software_info = '';
   my $descr = 'searchable archive of  reference manuals and documentations';   
   if ($obj->{conf}->get('intranet_version') eq 'no')
   {
       $software_info='<td align="right" rowspan="2" valign="bottom"><small>the&nbsp;last&nbsp;version of&nbsp;the&nbsp;software:&nbsp;<a class="menu" href="intranet_version.pl"><small>1.2&nbsp;-&nbsp;2004&nbsp;May&nbsp;03</small></a></small></td>';
       $descr='&nbsp;is an intranet, web-based, linux software which provides a&nbsp;searchable&nbsp;directory of&nbsp;reference&nbsp;manuals&nbsp;and&nbsp;documentations';
   }


    print qq!
   <body onLoad="init_doctaur();">
    <table width="100%" cellpadding="2" cellspacing="0">
        <tr>
            <td width="2%">&nbsp;</td>
            <td class="frame">
                <table cellpadding="5" cellspacing="0" border="0" width="100%">
                    <tr>
                      <td  class="top" >
                        <table cellpadding="0" cellspacing="0" border="0" width="100%">
                            <tr>
                                <td valign="bottom">
                                        <a border="0" href="$obj->{conf}->{conf}->{'url_dir'}/"><img height="49" border="0" src="redirection.pl?type=img&which=taurus-w2.gif" alt="" /></a>
                                </td>
                                 $software_info
                            </tr><tr>
                              <td><small>$descr</small></td>
                            </tr>
                        </table>
                      </td>
                    </tr>
                    <tr><td  class="frame"  height="2"><img src="redirection.pl?type=img&which=trn.gif" width="1" height="1" alt="" /></td></tr>
    !;
}

sub insert_menu
{
   my ($obj) = @_;
    my $big_img = '<img src="redirection.pl?type=img&which=pointer.gif" width="15" height="15" border="0" alt="" />';
    my $small_img = '<img src="redirection.pl?type=img&which=small_pointer.gif" width="12" height="12" border="0" alt="" />';
    if ($obj->{'script_name_wo'} ne 'doctaur')
    {
        print qq!
        <a class="menu" href="doctaur.pl?$obj->{qs}">${big_img}DocTaur&nbsp;main&nbsp;page</a><br />
        !;
    }else{
        print qq!        
        <a class="menu_active" href="doctaur.pl?$obj->{qs}">${big_img}DocTaur&nbsp;main&nbsp;page</a><br />
        !;
    }
    if ($obj->{conf}->get('intranet_version') eq 'no'){
        if ($obj->{script_name_wo} ne 'intranet_version' && $obj->{script_name_wo} ne 'request')
        {
            print qq!
                <a class="menu" href="intranet_version.pl?$obj->{qs}">${big_img}download&nbsp;intranet&nbsp;version</a><br />
            !;
        }
        else
        {
            print qq!
                <a class="menu_active" href="intranet_version.pl?$obj->{qs}">${big_img}download&nbsp;intranet&nbsp;version</a><br />
            !;
        }
    }

    if ($obj->{conf}->get('support_enabled') ne 'no'){
        if ($obj->{script_name_wo} ne 'support')
        {

        print qq!
            <a class="menu" href="support.pl?$obj->{qs}">${big_img}support</a><br />
            !;
        }else{
            print qq!        
            <a class="menu_active" href="support.pl?$obj->{qs}">${big_img}support</a><br />
            !;
        }
    }


    if ($obj->{script_name_wo} eq 'about' || $obj->{script_name_wo} eq 'search_help' || $obj->{script_name_wo} eq 'settings_help' || $obj->{script_name_wo} eq 'installation_help' || $obj->{script_name_wo} eq 'archive_expansion_help' || $obj->{script_name_wo} eq 'release_notes')
    {
        print qq!
        <A CLASS="menu_active" HREF="about.pl?$obj->{qs}">${big_img}help</A><BR>
        !;
        if ($obj->{script_name_wo} ne 'about')
        {
            print qq!
                &nbsp;&nbsp;&nbsp;<a class="menu" href="about.pl?$obj->{qs}">${small_img}<small>about DocTaur</small></a><br />
            !;
        }
        else
        {
            print qq!
                &nbsp;&nbsp;&nbsp;<a class="menu_active" href="about.pl?$obj->{qs}">${small_img}<small>about DocTaur</small></a><br />
            !;
        }
        if ($obj->{script_name_wo} ne 'search_help')
        {
            print qq!
                &nbsp;&nbsp;&nbsp;<a class="menu" href="search_help.pl?$obj->{qs}">${small_img}<small>searching help</small></a><br />
            !;
        }
        else
        {
            print qq!
                &nbsp;&nbsp;&nbsp;<a class="menu_active" href="search_help.pl?$obj->{qs}">${small_img}<small>searching help</small></a><br />
            !;
        }

        if ($obj->{conf}->get('help_enabled') ne 'no')
        {
            if ($obj->{script_name_wo} ne 'installation_help')
            {
                print qq!
                    &nbsp;&nbsp;&nbsp;<a class="menu" href="installation_help.pl?$obj->{qs}">${small_img}<small>installation help</small></a><br />
                !;
            }
            else
            {
                print qq!
                    &nbsp;&nbsp;&nbsp;<a class="menu_active" href="installation_help.pl?$obj->{qs}">${small_img}<small>installation help</small></a><br />
                !;
            }

            if ($obj->{script_name_wo} ne 'archive_expansion_help')
            {
                print qq!
                    &nbsp;&nbsp;&nbsp;<a class="menu" href="archive_expansion_help.pl?$obj->{qs}">${small_img}<small>archive expansion help</small></a><br />
                !;
            }
            else
            {
                print qq!
                    &nbsp;&nbsp;&nbsp;<a class="menu_active" href="archive_expansion_help.pl?$obj->{qs}">${small_img}<small>archive expansion help</small></a><br />
                !;
            }

            if ($obj->{script_name_wo} ne 'settings_help')
            {
                print qq!
                    &nbsp;&nbsp;&nbsp;<a class="menu" href="settings_help.pl?$obj->{qs}">${small_img}<small>settings & tools help</small></a><br />
                !;
            }
            else
            {
                print qq!
                    &nbsp;&nbsp;&nbsp;<a class="menu_active" href="settings_help.pl?$obj->{qs}">${small_img}<small>settings & tools help</small></a><br />
                !;
            }

            if ($obj->{script_name_wo} ne 'release_notes')
            {
                print qq!
                    &nbsp;&nbsp;&nbsp;<a class="menu" href="release_notes.pl?$obj->{qs}">${small_img}<small>release notes</small></a><br />
                !;
            }
            else
            {
                print qq!
                    &nbsp;&nbsp;&nbsp;<a class="menu_active" href="release_notes.pl?$obj->{qs}">${small_img}<small>release notes</small></a><br>
                !;
            }
        }

    }
    else
    {
        print qq!
        <a class="menu" href="about.pl?$obj->{qs}">${big_img}help</a><br />
        !;
    }

    if ($obj->{script_name_wo} eq 'login' || $obj->{script_name_wo} eq 'entrance' || $obj->{script_name_wo} eq 'settings' || $obj->{script_name_wo} eq 'messages' || $obj->{script_name_wo} eq 'settings_proccess' || $obj->{script_name_wo} eq 'tools' || $obj->{script_name_wo} eq 'inserter')
    {
         print qq!
           <a class="menu_active" href="entrance.pl?$obj->{qs}">${big_img}administrator</a><br />
        !;
    
        if ($obj->{script_name_wo} ne 'entrance' && $obj->{script_name_wo} ne 'login')
        {
            print qq!
                &nbsp;&nbsp;&nbsp;<a class="menu" href="entrance.pl?$obj->{qs}">${small_img}<small>entrance</small></a><br />
            !;
        }
        else
        {
            print qq!
                &nbsp;&nbsp;&nbsp;<a class="menu_active" href="entrance.pl?$obj->{qs}">${small_img}<small>entrance</small></a><br />
            !;
        }

        if ($obj->{script_name_wo} ne 'settings')
        {
            print qq!
                &nbsp;&nbsp;&nbsp;<a class="menu" href="settings.pl?$obj->{qs}">${small_img}<small>settings</small></a><br />
            !;
        }
        else
        {
            print qq!
                &nbsp;&nbsp;&nbsp;<a class="menu_active" href="settings.pl?$obj->{qs}">${small_img}<small>settings</small></a><br />
            !;
        }

        if ($obj->{script_name_wo} ne 'tools')
        {
            print qq!
                &nbsp;&nbsp;&nbsp;<a class="menu" href="tools.pl?$obj->{qs}">${small_img}<small>tools</small></a><br />
            !;
        }
        else
        {
            print qq!
                &nbsp;&nbsp;&nbsp;<a class="menu_active" href="tools.pl?$obj->{qs}">${small_img}<small>tools</small></a><br />
            !;
        }

        if ($obj->{script_name_wo} ne 'messages')
        {
            print qq!
                &nbsp;&nbsp;&nbsp;<a class="menu" href="messages.pl?$obj->{qs}">${small_img}<small>messages</small></a><br />
            !;
        }
        else
        {
            print qq!
                &nbsp;&nbsp;&nbsp;<a class="menu_active" href="messages.pl?$obj->{qs}">${small_img}<small>messages</small></a><br />
            !;
        }
        
        print qq!
            &nbsp;&nbsp;&nbsp;<a class="menu" href="logoff.pl?$obj->{qs}">${small_img}<small>log out</small></a><br />
        !;

    }
    else
    {
        print qq!
        <a class="menu" href="entrance.pl?$obj->{qs}">${big_img}administrator</a><br />
        !;
    }
}


sub insert_search_or_description
{
        print qq!
                      <table cellpadding="0" cellspacing="0" border="0">
                        <tr>
                            <td align="left"  colspan="2">
                                <b><small>
                                    Intranet directory useful for searching in and classifying of reference manuals.
                                </small></b>
                            </td>
                        </tr>
                        <tr>
                            <td align="left" colspan="2" nowrap="nowrap">
                                    <b><small>
                                      Features:
                                    </small></b>
                            </td>
                        </tr>
                        <tr>
                            <td align="left" colspan="1" nowrap="nowrap">
                                    <small>&nbsp;&nbsp;searchable: </small>
                            </td>
                            <td align="left" colspan="1" nowrap="nowrap">
                                    <small>searching in all or one folder of directory</small>
                            </td>
                        </tr>        
                        <tr>
                            <td align="left" colspan="1" nowrap="nowrap">
                                    <small>&nbsp;&nbsp;extensible:&nbsp;</small>
                            </td>
                            <td align="left" colspan="1" nowrap="nowrap">
                                    <small>you can <\!-- easiely -->  add new documentations</small>
                            </td>
                        </tr>        

<\!--                        <tr>
                            <td align=left colspan=2 nowrap>
                                    <small>&nbsp;&nbsp;fine selection of manual references included</small>
                            </td>
                        </tr>        -->
                    </table>
                  </td>
    !;
}

sub insert_title
{
   my ($obj, $title) = @_;
   print qq!
                           <tr><td  class="current_folder" ><big><b>$title</b></big></td>
                           </tr>
                           <tr><td class="main"  ><br />
   !;
}

sub insert_foot
{
	my ($obj) = @_;
	my $datapro_info = '';
	
	if ($obj->{conf}->get('intranet_version') eq 'no')
	{
		$datapro_info = '<div style="float:left;"><font class="smaller">in co-operation with <a class="foot" href="http://www.datapro.cz">DataPro
Solutions, s.r.o.</a></font></div>';
	}
        print qq!
                            </td></tr>
                            <tr class="frame_white"><td ><img src="redirection.pl?type=img&which=trn.gif" width="1" height="1" border="0" alt=""></td></tr>
                            <tr>
                              <td class="foot" nowrap="nowrap">$datapro_info
                                <font class="smaller">
                                    <a  class="foot" href="mailto:info\@doctaur.com">info\@doctaur.com</a>, DocTaur Copyright &copy; 2002-2004 <a  class="foot" href="http://www.doctaur.com/cgi-bin/about.pl">doctaur.com</a>, licence information: <a href="../GPL" class="foot">GPL</a>
                                </font>
                              </td>
                            </tr>
                        </table></td>
                    <td width="2%">&nbsp;</td>
                </tr>
            </table>
        !;
        print "</body></html>";
}




1;

#####################################################################################################################
#####################################################################################################################
package Insert_parts_dir;
use strict;
use vars ('@ISA');
@ISA = qw (Insert_parts);

use Doctaur_libs::Folders;

sub open
{
   my ($pkg) = @_;
   my $obj = $pkg->SUPER::open();
   $obj->{folders} = Folders->open();
   return $obj;
}

sub if_doc_redirect
{
   my ($obj) = @_;

   if ($obj->{folders}->is_leaf($obj->{conf}->get('dtdocs_path').$obj->{params}->get('dir')))
   {
      $_=$obj->{params}->get('dir');
      s/\/$//;
      print "Status: 302 Temporarily Moved\r\nLocation: ".$obj->{conf}->get('first_part_url').$_."\r\n\r\n";
      #.'<meta http-equiv="Refresh" content="0; URL='.$conf{'first_part_url'}.$params{dir}.'">';
      die;
   }

}

sub insert_search_or_description
{
    my ($obj) = @_;
    my $current_folder_html_code = $obj->get_current_folder_html_code();
    print qq
    !<table cellpadding=0 cellspacing=0 border="0">
      <tr><td width=20 colspan=3 height=3><img src="redirection.pl?type=img&which=trn.gif" width=1 height=1></td></tr>
      <tr><td width=20>&nbsp;</td><td align=left valign=top>
        <table class="search" border="0">
         <form method="post" action="htsearch" name="search_form" target="_blank" onsubmit="search_send(this);">
            <tr>
               <td align="left" nowrap="nowrap">
                  <input type="checkbox" id="results_window" name="results_window" onClick="if(this.checked) set_cookie('results_w', 'new'); else set_permanent_cookie('results_w', 'same')" />show results in a new window
               </td>
               <td align="right" nowrap="nowrap">
                 match: <select name="method">
                 <option value="and">all
                 <option value="or">any
                 <option value="boolean">boolean
                 </select>
                 <input type="hidden" name="config" value="htdig" />
                 <input type="hidden" name="restrict" value="$obj->{conf}->{conf}->{first_part_url}" />
                 <input type="hidden" name="exclude" value="" />
                 <input type="hidden" name="first_part_url" value="$obj->{conf}->{conf}->{first_part_url}" />
                 <input type="hidden" name="current_folder" value="$obj->{params}->{params}->{dir}" />
                 <input type="hidden" name="current_folder_html_code" value="$current_folder_html_code" />
                 <input type="hidden" name="ia_ver" value="$obj->{conf}->{conf}->{intranet_version}" />
                 <input type="hidden" name="support_enabled" value="$obj->{conf}->{conf}->{support_enabled}" />
               </td>
             </tr>
             <tr><td colspan="2"  align="center" nowrap="nowrap">
                 <input type="text" name="words" value="" class="search_query" />
                 <input type="button" value="search" onclick="search_send(this.form);" /></td></tr>
           </form>
         </table>

      </td><td width=20>&nbsp;</td></tr>
    </table>
    !;
}

sub insert_title
{
   my ($obj) = @_;
   print qq!
   <tr>
      <td  class="current_folder" >
         <table cellspacing=0 cellpadding=0 border=0>
            <tr>
               <td align=left class="current_folder"><b>selection for searching:</b>&nbsp;&nbsp;</td>
               <td align=left class="current_folder"><b><span id="selection_for_searching">
   !;
   print $obj->get_current_folder_html_code();
   print qq!</span>
               </b></td>
            </tr>
         </table>
      </td>
   </tr>
   <tr><td class="main" ><br />
   !;
}

sub get_current_folder_html_code
{
    my ($obj) = @_;
    my @temp = split("/", $obj->{params}->get('dir'));
    my $count_path='';
    my $return = qq!/ DocTaur!;
    foreach my $onefolder (@temp)
    {
        if ($onefolder && $onefolder ne '/')
        {
            $count_path.=$onefolder.'/';
            my $one_folder_name = $obj->{folders}->get_item_name($obj->{conf}->get('dtdocs_path').$count_path);
            $return.= qq!/$one_folder_name!;
        }
    }
    $return=~s/"//g;
    return  $return;
}

sub print_all_items
{
   my ($obj) = @_;
   print '<div class="dir_structure">';
   $obj->print_item_recur('', '', 'open', 'first');
   print "</div>";
}

sub print_manual
{
   my ($obj, $url, $dir, $index, $name, $dir_pa, $last) = @_;
   if ($obj->{params}->get('se')) {
      print qq!
         <a href="$url$index" title="open manual" class="manual" >$name</a><br />
      !;
   }
   else
   {
      print qq!
         <div class="item">
            <div class="$last">
               <div class="manual_$last">
                  <div class="item_margin">
                     <a href="$url$index" title="open manual" class="manual" ><img border="0" src="redirection.pl?type=img&which=icon_manuals_big.png" alt="" />$name</a>&nbsp;<a href="#" class="indir_action" onClick="change_selection_for_searching(document.search_form, '$dir', '$dir_pa')">&raquo;&nbsp;select for searching</a>
                  </div>
               </div>
            </div>
         </div>
      !;
   }
}

sub print_folder_start
{
   my ($obj, $dir, $name, $dir_pa, $open, $last) = @_;
   my $link = '<a href="#" title="" class="folder" onClick="return change_folder_state(this);">';
   print qq!
      <div class="item">
         <div class="$last">
            <div class="folder_${open}_$last" is_last="$last" is_open="$open">
               <div class="item_margin">
                  $link<img border="0" src="redirection.pl?type=img&which=trn.gif" width="16" height="5" /><img border="0" src="redirection.pl?type=img&which=icon_folder_$open.png" alt="" />$name</a>&nbsp;<a href="#" class="indir_action" onClick="change_selection_for_searching(document.search_form, '$dir', '$dir_pa')">&nbsp;&raquo;&nbsp;select for searching</a><div class="folder_content_$open">
   !;
}

sub print_folder_end
{
   my ($obj, $name) = @_;
   print qq!
                  </div>
               </div>
            </div>
         </div>
      </div>
   !;
}


sub print_item_recur
{
   my ($obj, $dir, $dir_pa, $open, $last) = @_;
   if (!$dir || $dir =~ /[^\/]$/){$dir.='/', $dir_pa.=' / ';}
   my $absolute_dir = $obj->{conf}->get('prefix_dir').'/dtdocs'.$dir;
   my $url_dir = $obj->{conf}->get('url_complet').'/dtdocs'.$dir;
   my $name = $obj->{folders}->get_item_name($absolute_dir);
   $dir_pa.=$name;
   if ($obj->{folders}->is_leaf($absolute_dir))
   {
      $obj->print_manual($url_dir, $dir, $obj->{folders}->get_item_index($absolute_dir), $name, $dir_pa,$last);
   }
   else
   {
      if (!$obj->{params}->get('se')) {$obj->print_folder_start($dir, $name, $dir_pa, $open, $last);}
      my $subitems = $obj->{folders}->get_subitems($absolute_dir);
      my $i=0;
      foreach my $subitem (@{$subitems})
      {
         $i++;
         my $class_last="not_last";
         if ($i==@{$subitems}) {$class_last="last"}
         $obj->print_item_recur($dir.$subitem, $dir_pa, 'close', $class_last);
      }
      if (!$obj->{params}->get('se')) {$obj->print_folder_end($obj->{folders}->get_item_name($absolute_dir));}
   }
}


1;
